#ifndef FILEREADER_H
#include "../header/FileReader.h"
#define FILEREADER_H
#endif

#include <stdlib.h>
#include <string.h>



void Leggi(char *path,struct TGlobalS *GS)
{
//puntatore a file
FILE *file=NULL;


//indice
int i=0,j=0;


//Numero di uni su di una riga
int NumeroUni=0;

//Posizione uno
int PosUno=0;

file=fopen(path, "r");


//Controllo esistenza file
if(file==NULL)
	printf("il file non c'");
else
	printf("il file esiste");


//Lettura delle dimensioni
fscanf(file, "%d",&(*GS).NumRow);
fscanf(file, "%d",&(*GS).NumCol);

//Lettura array dei costi
(*GS).ArrayCosti=(int *)malloc(sizeof(int)*(*GS).NumCol);

for(i=0;i<(*GS).NumCol;++i)
{
	fscanf(file, "%d",&(*GS).ArrayCosti[i]);
}

//Alloco la stuttura contenete il numeor di uno per riga
(*GS).NumUnoPerRow=(int*)malloc(sizeof(int)* (*GS).NumRow);

//Lettura array di liste inidici coperti
(*GS).MatriceCoeff=(int **)malloc(sizeof(int*)*(*GS).NumRow );

//Creazione matrice zero uni
(*GS).MatrixZeroOne=(int **)malloc(sizeof(int*)*(*GS).NumRow );

for(i=0;i<(*GS).NumRow;++i)
{
	
	
	//Leggo il numero di variabili settate a uno sulla riga i-esima
	fscanf(file, "%d",&NumeroUni);
	(*GS).MatriceCoeff[i]=(int *)malloc(sizeof(int)* NumeroUni);

	//Alloco la riga della matrice di zero e uni
	(*GS).MatrixZeroOne[i]=(int *)malloc(sizeof(int)* (*GS).NumCol);

	for(j=0;j<(*GS).NumCol;++j)
		(*GS).MatrixZeroOne[i][j]=0;
		
    //Mantengo il numero di uno in una struttura a parte
	(*GS).NumUnoPerRow[i]=NumeroUni;
	
	//Setto gli uni della riga i-esima
	for(j=0;j<NumeroUni;++j)
	{
		
		fscanf(file, "%d",&PosUno);
		PosUno--;
		(*GS).MatriceCoeff[i][j]=PosUno;
		(*GS).MatrixZeroOne[i][PosUno]=1;
	}
	
}

//Alloco l'array delle penalit lagrangiane
(*GS).Penalties=(double*)malloc(sizeof(double)* (*GS).NumRow);

for(i=0;i<(*GS).NumRow;++i)
	(*GS).Penalties[i]=0.0;


fclose(file);

	
}

