#include<stdlib.h>
#include<stdio.h>
#include<math.h>
#include<string.h>




#define FIRST_NODE 0
#define DOUBLE_ZERO 0.0


struct TZeroCounter
{
	int *Column;
	int NumZero;
};



//Funzione che calcola il lower bound ungherese
double LowerBound( double **MatrixInput ,int DimMatrix,int DimNodiNonVisitati, int * NodiNonVisitati );

//Funzione che trov al minore da un Array
int FindMin(double * Array,int DimNodiNonVisitati);

//Elimina un valore da una colonna della matrice
double ** EliminaInColonna(double **MatrixInput,int Index,double Value,int DimNodiNonVisitati);

//Elimina un valore da un riga della matrice
double ** EliminaInRiga(double **MatrixInput,int Index,double Value,int DimNodiNonVisitati);

//Stampa a video la mtrice
void PrintMatrix(double **MatrixInput,int Dimension);

//Estrae una colonna dalla matrice
double *PrendiColonna(int NColonna,double ** MatrixInput,int DimNodiNonVisitati);


//Stampa il contenuto dell'array di interi con dimeansione dim
void StampaArray(int *Array, int Dim);

//Trova e sotrae il min di un sottomatrice e lo sosttrae ad esssa
void FindMinSubMatrix(double ***InputMatrix,int *ClumnIndex,int DimCI, int *RowIndex, int DimRI);

//Restituisce la somma dei costi dei collegamenti del grafo bipartito
double CalcolaSommaCosti(double **InputMatrix,double **CopyOfMatrix,int DimNodiNonVisitati);

//Copia una matrice e in un'altra e ne restituisce il puntatore
double **CloneMatrix(double **MatrixInput,int Dim,int *NodiNonVisitati,int DimNodiNonVisitati,bool *Stop);

//Dealloca una matrice
void DisposeMatrix(double ***MatrixInput,int Dim);

//Elimina un elemnto puntato da index
void DeleteElement(int **Array,int * Dim,int Index);

//Elimina la struttura che conta gli zero
void DisposeZeroStruct( TZeroCounter ** ZeroCounter,int Dim);

//Aggiunge un valore alla lista contenuta nell'array
void AddToArray(int **Array,int *Dim,int Value);

//Crea la struttura degli zeri per la verifica del matching 
void UpdateZeroStruct(double **Matrix,int Dim,TZeroCounter** ZeroCounter);

//Stampa a schermo la struttura degli zero
void PrintZeroStruct(TZeroCounter * ZeroCounter,int Dim);


double ** CloneMatrix2(double ** InputMatrix,int DimNodiNonVisitati);

double UpperBound( double **MatrixInput ,int DimMatrix,int DimNodiNonVisitati, int * NodiNonVisitati ,int LastNode);
int FirstIndexOfVal(int *Array,int Dim,int Val);

void FindMin2 (double *Array,int DimNodiNonVisitati,int *NodiNonVisitati,int *IndexRow);