 #include "../Header/LowerBoundUngherese.h"






double LowerBound( double **MatrixInput ,int DimMatrix,int DimNodiNonVisitati, int * NodiNonVisitati )
{
	//Indici
	int IndexMin=0,i=0,j=0,k=0,y=0;
	double *Colonna=NULL;
	bool is_maching_incomplete=false,Stop=false;
	
	int *ArrayIndiciColonna=NULL;
	int *ArrayIndiciRiga=NULL;
	int DimArrayIndiciColonna=0, DimArrayIndiciRiga=0;
	double SommaCosti=0;
	double **CopyOfMatrix,**CopyOfMatrix2;
	
	TZeroCounter *ZeroCounter;

	CopyOfMatrix=CloneMatrix(MatrixInput,DimMatrix,NodiNonVisitati,DimNodiNonVisitati,&Stop);


	/*printf("La matrice prima dell'elimanzione delle righe :\n");
	PrintMatrix(CopyOfMatrix,DimNodiNonVisitati);
	getchar();*/
	//Controllo se la matrice  composta tutta da il medesimo valore
	if(Stop)
		return CopyOfMatrix[0][0]*DimNodiNonVisitati;

	CopyOfMatrix2=CloneMatrix2(CopyOfMatrix,DimNodiNonVisitati);

	//Elimino il minimo di ogni roga a ogni  riga
	for(i=0; i<DimNodiNonVisitati; i++)
	{		
			IndexMin= FindMin(CopyOfMatrix[i],DimNodiNonVisitati);

			//Se il valore Min  zero non faccio niente
			if(CopyOfMatrix[i][IndexMin]==DOUBLE_ZERO)
			{
				continue;
			}

			CopyOfMatrix=EliminaInRiga(CopyOfMatrix,i,CopyOfMatrix[i][IndexMin],DimNodiNonVisitati);
			
	}
	/*printf("\nLa matrice dopo dell'elimanzione delle righe :\n");
	PrintMatrix(CopyOfMatrix,DimNodiNonVisitati);
	getchar();*/

	//Elimino il minimo di colonna riga a colonna
	for(i=0; i<DimNodiNonVisitati; i++)
	{		
			Colonna =PrendiColonna(i,CopyOfMatrix,DimNodiNonVisitati);
			IndexMin= FindMin(Colonna,DimNodiNonVisitati);
		
			//Se il valore Min  zero non faccio niente
			if(CopyOfMatrix[IndexMin][i]==DOUBLE_ZERO)
			{
				free(Colonna);
				continue;
			}

			CopyOfMatrix=EliminaInColonna(CopyOfMatrix,i,CopyOfMatrix[IndexMin][i],DimNodiNonVisitati);
			free(Colonna);

	}
	/*printf("\nLa matrice dopo dell'elimanzione delle colonne :\n");
	PrintMatrix(CopyOfMatrix,DimNodiNonVisitati);*/
	UpdateZeroStruct(CopyOfMatrix,DimNodiNonVisitati,&ZeroCounter);

	/*PrintZeroStruct(ZeroCounter,DimNodiNonVisitati);
	getchar();*/
	//ORA DOVR STABILIRE SE ESEGUIRE LA PROCEDURA U OVVERO SOLO SE IL MATCHING  INCOMPLETO

	
	//Controllo se il matching  completo
	for(i=0; i<DimNodiNonVisitati; i++)
	{
		if(ZeroCounter[i].NumZero==1)
		{ 
			// Ciclo su tutte le righe
			for(j=i+1; j<DimNodiNonVisitati; j++)
			{
				// Se alla riga j ho trovato uno zero controllo ...
				if((ZeroCounter[j].NumZero==1 ))
				{
					// che sulla stessa colonna non ci sia un altro zero altrimenti ho matching incompleto
					if(ZeroCounter[j].Column[0] == ZeroCounter[i].Column[0] )
					{
								is_maching_incomplete=true;
								break;
					}
				}
			}
		}
		if(is_maching_incomplete)
		break;
	}



	if(is_maching_incomplete)
	{
		/*printf("Il matching non  completo");
		getchar();*/
		//QUI SCRIVERO LA PROCEDURA U

		
		//Creo lo spazio per gli array contenenti gli indici da tenere
		ArrayIndiciColonna=(int *)malloc(sizeof(int)*DimNodiNonVisitati);
		ArrayIndiciRiga=(int *)malloc(sizeof(int)*DimNodiNonVisitati);

	
		//Scorro tutte le righe
		for(i=0; i<DimNodiNonVisitati; i++)
		{
			if(ZeroCounter[i].NumZero==1)
			{ 
				for(j=i+1; j<DimNodiNonVisitati; j++)
				{
					if(ZeroCounter[j].NumZero==1 )
					{
						if(ZeroCounter[j].Column[0] == ZeroCounter[i].Column[0] )
						{


							AddToArray(&ArrayIndiciRiga,&DimArrayIndiciRiga,i);
							AddToArray(&ArrayIndiciRiga,&DimArrayIndiciRiga,j);
							//Aggiungo i nodi riga da mantenere
							for(k=0;k<DimNodiNonVisitati;++k)
							{

                                    if(ZeroCounter[j].Column[0]!= k)
									{
							          AddToArray(&ArrayIndiciColonna,&DimArrayIndiciColonna,k);
									}

							}
							
						}
					}
				}
			}
		}
		
	

		/*printf("\nGli indici colonna da mantenere sono");
		StampaArray(ArrayIndiciColonna, DimArrayIndiciColonna);
		printf("\nGli indici riga da mantenere sono");
		StampaArray(ArrayIndiciRiga, DimArrayIndiciRiga);
		getchar();*/
        FindMinSubMatrix(&CopyOfMatrix,ArrayIndiciColonna,DimArrayIndiciColonna, ArrayIndiciRiga, DimArrayIndiciRiga);
		
		/*printf("\nLa matrice dopo la procedura U vale \n");
		PrintMatrix(CopyOfMatrix,DimNodiNonVisitati);*/
	
		SommaCosti=CalcolaSommaCosti(CopyOfMatrix2,CopyOfMatrix,DimNodiNonVisitati);
		
	
		free(ArrayIndiciRiga);
		free(ArrayIndiciColonna);
		

	}
	else
		SommaCosti=CalcolaSommaCosti(CopyOfMatrix2,CopyOfMatrix,DimNodiNonVisitati);
		
	//printf("\nIl lowe bound vale %f\n",SommaCosti);
	DisposeMatrix(&CopyOfMatrix2,DimNodiNonVisitati);
	DisposeMatrix(&CopyOfMatrix,DimNodiNonVisitati);
	DisposeZeroStruct(&ZeroCounter,DimNodiNonVisitati);

return SommaCosti;
}

 int FindMin(double * Array,int DimNodiNonVisitati)
 {
	double help=HUGE_VAL;
	int IndexMin=0;
	for(int i=0; i<DimNodiNonVisitati ; i++)
	{
		if(Array[i]<help)
		{
			help=Array[i];
			IndexMin=i;
		}
	}
	return IndexMin;
 }

void FindMin2 (double *Array,int DimNodiNonVisitati,int *NodiNonVisitati,int *IndexCol)
 {
	double help=HUGE_VAL;
	int IndexMin=0;
	int i;
	for(i=0; i<DimNodiNonVisitati ; i++)
	{
		
			if(Array[NodiNonVisitati[i]]<help)
			{
				help=Array[NodiNonVisitati[i]];
				*IndexCol=NodiNonVisitati[i];
			}
	}
	
 }
double ** EliminaInRiga(double **MatrixInput,int Index,double Value,int DimNodiNonVisitati)
{
	
	for(int i=0; i<DimNodiNonVisitati ; i++)
	{
		MatrixInput[Index][i]=(MatrixInput[Index][i]-Value);
	}
	return MatrixInput;
}

double ** EliminaInColonna(double **MatrixInput,int Index,double Value,int DimNodiNonVisitati)
{

	for(int i=0; i<DimNodiNonVisitati ; i++)
	{
		MatrixInput[i][Index]=(MatrixInput[i][Index]-Value);
			
	}
	return MatrixInput;
}

void PrintMatrix(double **MatrixInput,int Dimension)
{
	int i=0,j=0;

	for(i=0;i<Dimension ;++i)
	{
		printf("\n");
		for(j=0;j<Dimension ;++j)
			printf("\t%d",(int)MatrixInput[i][j]);
	}
	printf("\n");
}
double *PrendiColonna(int NColonna,double ** MatrixInput,int DimNodiNonVisitati)
{
double * Colonna= (double*)malloc (sizeof(double)*DimNodiNonVisitati);
for(int i=0; i<DimNodiNonVisitati ; i++)
{
		Colonna[i]=MatrixInput[i][NColonna];
}
return Colonna;
}




void StampaArray(int *Array, int Dim)
{
int i;
printf("\n");
for(i=0;i<Dim;++i)
{
	printf("%d ",Array[i]);
}
}

void FindMinSubMatrix(double ***InputMatrix,int *ClumnIndex,int DimCI, int *RowIndex, int DimRI)
{
int i,j;
double min=HUGE_VAL;

	//Trovo il minimo
	for(i=0;i<DimCI;++i)
	{
		for(j=0;j<DimRI;++j)
		{
			if(min>(*InputMatrix)[RowIndex[j]][ClumnIndex[i]])
				min=(*InputMatrix)[RowIndex[j]][ClumnIndex[i]];
		}
	
	}
	//Sottraggo per tutti i valori il minimo
	for(i=0;i<DimCI;++i)
		for(j=0;j<DimRI;++j)
			(*InputMatrix)[RowIndex[j]][ClumnIndex[i]]-=min;
}
double CalcolaSommaCosti(double **InputMatrix,double **CopyOfMatrix,int DimNodiNonVisitati)
{
int i,j;
double SommaCosti=0;
int IndexZeroFound=0;
int * Nodi=(int *)malloc(sizeof(int)*DimNodiNonVisitati);
int DimNodi=DimNodiNonVisitati;

	for(i=0;i<DimNodiNonVisitati;++i)
		Nodi[i]=i;
	i=0;

	while(i<DimNodiNonVisitati)
	{
		for(j=0;j<DimNodi;++j)
		{
			if(CopyOfMatrix[i][Nodi[j]]==DOUBLE_ZERO)
			{
				SommaCosti+=InputMatrix[i][Nodi[j]];
				break;
			}
		}
		
		DeleteElement(&Nodi,&DimNodi,j);
		++i;
	}
	free(Nodi);
	return SommaCosti;
}
double **CloneMatrix(double **MatrixInput,int Dim,int *NodiNonVisitati,int DimNodiNonVisitati,bool *Stop)
{
double **MatrixCopy=(double **)malloc(sizeof(double*)*DimNodiNonVisitati);
int i,j,Counter=0;
double tmp=-1.0;
	for(i=0;i<(DimNodiNonVisitati);++i)
	{
		MatrixCopy[i]=(double *)malloc(sizeof(double)*DimNodiNonVisitati);
		for(j=0;j<DimNodiNonVisitati;++j)
		{
			
			MatrixCopy[i][j]=MatrixInput[NodiNonVisitati[i]][NodiNonVisitati[j]];
			if(MatrixInput[NodiNonVisitati[i]][NodiNonVisitati[j]]==tmp)
			{
				Counter++;
			}
			tmp=MatrixCopy[i][j];
			
		}
	}
	if(Counter==(DimNodiNonVisitati*DimNodiNonVisitati))
		(*Stop)=true;

return MatrixCopy;
}

void DisposeMatrix(double ***MatrixInput,int Dim)
{
int i;
	for(i=0;i<(Dim);++i)
	{
		free((*MatrixInput)[i]);	
	}
	free(*MatrixInput);
}

void DeleteElement(int **Array,int * Dim,int Index)
{

(*Array)[Index]=(*Array)[(*Dim)-1];
(*Dim)--;

}

void UpdateZeroStruct(double **Matrix,int Dim,TZeroCounter** ZeroCounter)
{
int i=0,j=0;
(*ZeroCounter)=(TZeroCounter*)malloc(sizeof(TZeroCounter)*Dim);
for(i=0;i<Dim;++i)
{
	(*ZeroCounter)[i].Column=(int *)malloc(sizeof(int)*Dim);
	(*ZeroCounter)[i].NumZero=0;
	for(j=0;j<Dim;++j)
	{
		if(Matrix[i][j]==DOUBLE_ZERO)
		{
			(*ZeroCounter)[i].Column[(*ZeroCounter)[i].NumZero]=j;
			(*ZeroCounter)[i].NumZero++;
		}
		
	}
}

}

void AddToArray(int **Array,int *Dim,int Value)
{
int i;
for(i=0; i<(*Dim) ;++i)
{
	if((*Array)[i]==Value)
	{
		return;
	}
}
(*Array)[(*Dim)]=Value;
(*Dim)++;
}


void DisposeZeroStruct( TZeroCounter ** ZeroCounter,int Dim)
{
	int i;
	for(i=0;i<Dim;++i)
	{
			free((*ZeroCounter)[i].Column);
	}

	free(*ZeroCounter);
}
void PrintZeroStruct(TZeroCounter * ZeroCounter,int Dim)
{
	int i,j;
		for(i=0;i<Dim;++i)
	{
		printf("\nNella riga %d ho %d Zero",i,ZeroCounter[i].NumZero);
			for(j=0;j<ZeroCounter[i].NumZero;++j)
			{
				printf("in %d ",ZeroCounter[i].Column[j]);
			}
	}

}
double ** CloneMatrix2(double ** InputMatrix,int DimNodiNonVisitati)
{
	double **MatrixCopy=(double **)malloc(sizeof(double*)*DimNodiNonVisitati);
	int i;

	for(i=0;i<(DimNodiNonVisitati);++i)
	{
		MatrixCopy[i]=(double *)malloc(sizeof(double)*DimNodiNonVisitati);
		memcpy(MatrixCopy[i],InputMatrix[i],sizeof(double)*DimNodiNonVisitati);
	}

	return MatrixCopy;
}

double UpperBound( double **MatrixInput ,int DimMatrix,int DimNodiNonVisitati, int * NodiNonVisitati ,int LastNode)
{

int i=0;
int IndexMinCol=0,tmp=0,DimNodiNonVisitatiCopy=DimNodiNonVisitati;
double SommaCosti=0.0;

int * NodiNonVisitatiCopy= (int*)malloc(sizeof(int)*DimNodiNonVisitati);	
memcpy(	NodiNonVisitatiCopy,NodiNonVisitati,(sizeof(int)*DimNodiNonVisitati));


	
	for(i=0;i<DimNodiNonVisitatiCopy;++i)
	{
		//Trovo il minimo della righa dell'ultim nodo visitato
		FindMin2(MatrixInput[LastNode],DimNodiNonVisitati,NodiNonVisitatiCopy,&IndexMinCol);
		
		//Incremento il valore con il valore del minimo
		SommaCosti+=MatrixInput[LastNode][IndexMinCol];

		//Indice del minimo trovato sar l'ultimo eplorato
		LastNode=IndexMinCol;

		//Elimino la cella contente l'ultimo nodo esplorato
		tmp=FirstIndexOfVal(NodiNonVisitatiCopy,DimNodiNonVisitati,IndexMinCol);
		DeleteElement(&NodiNonVisitatiCopy,&DimNodiNonVisitati,tmp);
		
	}

	free(NodiNonVisitatiCopy);
		


SommaCosti+=MatrixInput[0][LastNode];


return SommaCosti;
}

int FirstIndexOfVal(int *Array,int Dim,int Val)
{
	int i;
	for(i=0;i<Dim;++i)
	{
		if(Array[i]==Val)
			return i;
	}
	return i;
}
void prova()
{
	int i=0,j=0,y=0;
	int NodiNonVis[]={0,1,2,3,4,5,6};
	double SommaCosti=0.0;
	int N =7;
	double **MatrixInput2=(double **)malloc(sizeof(double)*N);


	for(i=0;i<(N);++i)
		MatrixInput2[i]=(double *)malloc(sizeof(double)*N);



for(y=0;y<1000000;++y)
{


for(i=0;i<N;++i)
	for(j=0;j<N;++j)
	MatrixInput2[i][j]=(double)rand();
	
	SommaCosti=LowerBound(MatrixInput2,7,7,NodiNonVis);
	
	printf("\nLa somma dei costi vale %f alpasaggio %d\n",SommaCosti,y);

	
}


}