#include "../Header/GlobalParam.h"
#include "string.h"
#include <time.h>
#include <math.h>
using namespace std;
#define RANDOM_LIMIT 999
#define RANDOM_GEN 0
int NUM_TESTS=100;


int N=15; 
double ** DistanceMatrix ; /*matrice delle distanze*/
TBrenchStruct *BrenchTree;
TStat Stat;


TBrenchStruct* best=NULL;
void AllocMatrix(double *** DistanceMatrix);
void FreeMatrix(double *** DistanceMatrix);
void RandomGenerator(double *** DistanceMatrix);
int main(int argc, char *argv[])

{
	long nodicreati=0;
	double ub=92.0;
	int i=0,j=0,MaxLung=0;
	time_t t1,t2;
	TBrenchStruct * last=NULL;
	char nome_file[50];

	printf("Nodi \t nodic \t MaxLung \t Tempo");
	
	if(!RANDOM_GEN)
	{
		for(i=11;i<17;++i )
		{	
			
			sprintf(nome_file,"br17/br%d.atsp",i);
			CaricaDati(nome_file,&DistanceMatrix,&N);
			StampaDati(DistanceMatrix, N);
			
			t1= time(NULL);
			Init_BrenchStruct(N,&BrenchTree,&Stat);
			last=BrenchTree;
			Search(&BrenchTree, Stat,DistanceMatrix,N,&best,&nodicreati,&ub,&last,&MaxLung);
			t2= time(NULL);
			//printf("\nLa soluzione e'");
			//Sol_disp(best,N);
			printf("\n %d \t %d \t %d",i,nodicreati,MaxLung);
			printf("\t %d",(t2-t1));
		}
	}
	else
	{
		
		
		for(j=15 ;j<19;j+=2 )
		{
			N=j;
			AllocMatrix(&DistanceMatrix);
			printf("\n nodi %d\n",N);
			for(i=0;i<NUM_TESTS;++i)
			{
				ub=HUGE_VAL;
				nodicreati=0;
				RandomGenerator(&DistanceMatrix);
				t1= time(NULL);
				Init_BrenchStruct(N,&BrenchTree,&Stat);
				last=BrenchTree;
				Search(&BrenchTree, Stat,DistanceMatrix,N,&best,&nodicreati,&ub,&last,&MaxLung);
				t2= time(NULL);
				//printf("\nLa soluzione e'");
				//Sol_disp(best,N);
				printf("\n %d \t %d \t %d",i,nodicreati,MaxLung);
				printf("\t %d",(t2-t1));
			}
			FreeMatrix(&DistanceMatrix);
		}
	}


  return 1;//EXIT_SUCCESS;
}

void RandomGenerator(double *** DistanceMatrix)
{
	int i,j;

	
	for(i=0;i<N;++i)
		for(j=0;j<N;++j)
		{
			if(j==i)
				(*DistanceMatrix)[i][j]=9999;
			else
				(*DistanceMatrix)[i][j]=(int)(RANDOM_LIMIT * (rand() / ((double)RAND_MAX + 1)));
		}
}

void AllocMatrix(double *** DistanceMatrix)
{
	int i;
	(*DistanceMatrix)=(double**)malloc(sizeof(double*)*N);

	for(i=0;i<(N);++i)
		(*DistanceMatrix)[i]=(double*)malloc(sizeof(double)*N);

}
void FreeMatrix(double *** DistanceMatrix)
{
int i;
	for(i=0;i<(N);++i)
		free((*DistanceMatrix)[i]);
	free(*DistanceMatrix);
}
