#include "../header/SubGradient.h"
#include "../header/TreeLib.h"


extern struct TGlobalS GS;
extern float  ub;
extern float Fix;
extern int Delete;
extern float LBTMP;

float  SubGradientLoop(struct TBrenchStruct *p, int NIteration, float  Alpha,int *is_optimal_reached)
{


//Valori Upper e Lower bound
float  LowerBoundValue=-999999;
float  UpperBoundValue=99999,SommaPenalties=0;



//True se la soluzione  migliorante
int is_better;



float  UB=99999;


//Indici
int i,j;

//Variabili temporanee
float  Theta=0.0,tmp=0.0;
int Count=0;

(*is_optimal_reached)=FALSE;

//Inizializzoi costi ridotti
for(i=0;i<GS.LB.TempColList.size;++i)
{
	GS.LB.CostoRidotti.Values[i]=0;
	GS.LB.SensAnalFC.IsFixed[i]=FALSE;
}
for(i=0;i<GS.LB.Penalties.size;++i)
{
	GS.LB.Penalties.Values[i]=0;
	GS.LB.FixedRow.Values[i]=FALSE;
}
Fix=0;
for(i=0;i<NIteration;++i)
{
	//LowerBoundValue=0;
	is_better=FALSE;
	tmp=0.0;

	//Calcolo Lower Bound e Upper Bound solo se ho un'terazione migliorante
	LagrangeLB(&UB,&LowerBoundValue,SommaPenalties,&is_better);
	
	
	//Controllo ottimalit ammissibilit soluzione soluzione e allo stesso tempo aggiorno i subrgradienti
	UpdateSub();	
	
	//Controllo per l'uscita dal ciclo
	if(Alpha<ALPHA_LIMIT )
	{
		ub=UB;
	
		return LBTMP;
	}

	//Aggiornamento del Lower Bound
	if(is_better)
	{
		Count=0;
		
		if(LowerBoundValue==UB )
		{
			ub=UB;
			(*is_optimal_reached)=TRUE;
			printf("ho raggiunto l'ottimo");
			return LBTMP;
		}
	

	}
	else
	{
		Count++;
		if(Count>=DELTAMAX)
		{
			Count=0;
			Alpha/=2;
		}
	}

	
	
	//Aggionamento di Theta
	for(j=0;j<GS.LB.TempRowList.size;++j)
		tmp+=(GS.LB.SubGradienti.Values[GS.LB.TempRowList.Values[j]]*GS.LB.SubGradienti.Values[GS.LB.TempRowList.Values[j]]);
	

	//if((UB-LowerBoundValue)<0.05)
		Theta=(Alpha*((UB*UB_INC)-LowerBoundValue))/tmp;
	//else
	//	Theta=(Alpha*((UB)-LowerBoundValue))/tmp;
	//Aggiornamento penalit lagrangiane
	UpdateLagrngianPenalties(Theta,&SommaPenalties);

}
ub=UB;
return LBTMP;
}
float  NodeSubGradientLoop(int k,struct TBrenchStruct * p,struct TBrenchStruct * padre, int NIteration, float  Alpha,int *is_optimal_reached )
{


//Valori Upper e Lower bound
float  LowerBoundValue=-999999;
float  SommaPenalties=0;


//True se la soluzione  migliorante
int is_better;

//TRue se la soluzione  ammissibile
int is_ammissibile;

float  UB=99999;//ub-(GS.ArrayCosti[ColonnaEliminata]*k);


//Indici
int i,j,t;

//Variabili temporanee
float  Theta=0.0,tmp=0.0;
int Count=0;

Fix=0;
Delete=FALSE;
//Inizializzoi costi ridotti
for(i=0;i<GS.LB.TempColList.size;++i)
{
	GS.LB.CostoRidotti.Values[i]=0;
	GS.LB.SensAnalFC.IsFixed[i]=FALSE;
}

(*is_optimal_reached)=FALSE;
	
memcpy(GS.LB.Penalties.Values,padre->penalties,sizeof(float)*GS.LB.Penalties.size);

for(i=0;i<GS.LB.TempRowList.size;++i)
{
	t=GS.LB.TempRowList.Values[i];
	GS.LB.FixedRow.Values[t]=FALSE;
	SommaPenalties+=GS.LB.Penalties.Values[t];
}
for(i=0;i<NIteration;++i)
{
	//LowerBoundValue=0;
	is_better=FALSE;
	is_ammissibile=FALSE;
	tmp=0.0;

	
	//Calcolo Lower Bound e Upper Bound solo se ho un'terazione migliorante
	if(!LagrangeLB(&UB,&LowerBoundValue,SommaPenalties,&is_better))
	{
		return LBTMP;
	}

	
	
	//aggiorno i subrgradienti
	UpdateSub();
	
	
	//Controllo per l'uscita dal ciclo
	if(Alpha<ALPHA_LIMIT)
	{
	
		return LowerBoundValue;
	}
	/*if(LowerBoundValue>UB)
	{
		is_better=FALSE;
		return LowerBoundValue;
	}*/	
	//Aggiornamento del Lower Bound
	if(is_better )
	{
		Count=0;
		
		if(LowerBoundValue==UB )
		{
			(*is_optimal_reached)=TRUE;
		
			return LBTMP;
		}
	

	}
	else
	{
		Count++;
		if(Count>=DELTAMAX)
		{
			Count=0;
			Alpha/=2;
		}
	}

	
	
	//Aggionamento di Theta
	for(j=0;j<GS.LB.TempRowList.size;++j)
		tmp+=(GS.LB.SubGradienti.Values[GS.LB.TempRowList.Values[j]]*GS.LB.SubGradienti.Values[GS.LB.TempRowList.Values[j]]);

	//if((UB-LowerBoundValue)<0.05)
	//	Theta=(Alpha*((UB*UB_INC)-LowerBoundValue))/tmp;
//	else
	Theta=(Alpha*((UB)-LowerBoundValue))/tmp;
	

	//Aggiornamento penalit lagrangiane
	UpdateLagrngianPenalties(Theta,&SommaPenalties);

}

//printf("\nEsco perch ho fatto tutte le iterazioni\n");
return LBTMP;
}

void UpdateSub()
{

int i,j;

int Counter=0;


	//Per tu tutti gli n elementi dell soluzione
		
		for(i=0;i<GS.LB.TempRowList.size;++i)
		{
			Counter=0;
			GS.LB.SubGradienti.Values[GS.LB.TempRowList.Values[i]]=1.0;
			for(j=0;j<GS.LB.LBSolutionTmpIndexList.size;++j)
			{
				Counter+=GS.MatrixZeroOne[GS.LB.TempRowList.Values[i]][GS.LB.LBSolutionTmpIndexList.Values[j]];
			}

			GS.LB.SubGradienti.Values[GS.LB.TempRowList.Values[i]]-=Counter;	
		

		}
}





void UpdateLagrngianPenalties(float  Theta,float  * SommaPenalties)
{
	int i;
	float  tmp;

	(*SommaPenalties)=0;

	for(i=0;i<GS.LB.TempRowList.size;++i)
	{
		tmp=GS.LB.Penalties.Values[GS.LB.TempRowList.Values[i]]+(Theta*GS.LB.SubGradienti.Values[GS.LB.TempRowList.Values[i]]);
		if(tmp>0)
		{
			GS.LB.Penalties.Values[GS.LB.TempRowList.Values[i]]=tmp;
			(*SommaPenalties)+=tmp;
		}
		else
			GS.LB.Penalties.Values[GS.LB.TempRowList.Values[i]]=0.0;
	}
}


void PrintArray2(float  *Array,int Dim)
{
    int i=0;
	for(i=0;i<Dim; i++)
	{
	  printf("%f\t",Array[i]);
	}
}


